/* linkoid.c          Tue 6/26/01 5:59 pm
Tue 04-17-2001  creation.
Tue 6/26/01 5:59 pm   unlinked.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include <alloc.h>
//#include <tla.h>
#if defined(__FLAT__)
#include <stdarg.h>
#include <io.h>
#endif

#define YES (1)
#define NO (0)

#define _f  /* harmless prototoype catcher. */
#define _v  /* like same for vars. */


#ifndef BYTE
  #define BYTE char
#endif

typedef unsigned char UCHAR;

#ifdef Nuthin__FLAT__
  #error You may have troubles with signed chars. Use UCHAR?
  #error Or something ("int c = (unsigned char)getc()"?)
#endif

#ifndef sBYTE
  #define sBYTE signed char
#endif

#ifndef WORD
  typedef unsigned int WORD;
#endif

#ifndef BIG
  typedef unsigned long BIG;
#endif

#define ARRAYSIZE(x) (sizeof(x) / sizeof(x[0]))

#define ENTER (13)
#define CR (13)
#define LF (10)
#define CTL (0x40)        /* 'A'-CTL is ^A. */
#define ESC (0x1b)
#define DEL (0x5300)
#define BS (8)
#define TAB (9)

#define sCR  "\xD"
#define sLF  "\xA"
#define sDEL "\x7f"
#define sACK "\x6"
#define sESC "\x1b"
#define sBEL "\x7"

#define BIT0 (1)
#define BIT1 (2)
#define BIT2 (4)
#define BIT3 (8)
#define BIT4 (16)
#define BIT5 (32)
#define BIT6 (64)
#define BIT7 (128)
#define BIT8 (256)
#define BIT9 (512)
#define BIT10 (1024)
#define BIT11 (2048)
#define BIT12 (4096)
#define BIT13 (8192)
#define BIT14 (16384)
#define BIT15 (32768)
#define BIT16 (65536)
#define BIT17 (131072)
#define BIT18 (262144)
#define BIT19 (524288)
#define BIT20 (1048576)
#define BIT21 (2097152)
#define BIT22 (4194304)
#define BIT23 (8388608)
#define BIT24 (16777216)
#define BIT25 (33554432)
#define BIT26 (67108864)
#define BIT27 (134217728)
#define BIT28 (268435456)
#define BIT29 (536870912)
#define BIT30 (1073741824)
#define BIT31 (2147483648)

#define nBIT(x) (1 << (x))                          /*  */
/* this doesn't work with BIGs. Then it should be
  #define nBIT(x) ((BIG)(((BIG)1) << ((BIG)x)))
*/

#define lo(one,two) ( ((one) < (two)) ? (one) : (two))    /*  */
#define hi(one,two) ( ((one) > (two)) ? (one) : (two))    /* not tested. */

#define kLOW(x) ((x) & 255)
#define kHIGH(x) (((x) >> 8)&255)

/* kill annoying error messages from JGW LOW, HIGH def. */
#ifdef LOW
  #undef LOW
#endif
#ifdef HIGH
  #undef HIGH
#endif

#define LOW(x)  (((BYTE *)&(x))[0])
#define HIGH(x) (((BYTE *)&(x))[1])


/****************************************************************************
****************************************************************************/

#define DEBUGBSCAM NO   /*Thu 7/19/01 11:46 am didn't find broken bscam link.
Reference in javapage.htm to rant4.htm#bscam, but acheral ref in
rant5.htm#bscam. */

/*#define LINENUMBERS YES /* always line numbers now Fri 8/04/2006 5:03 pm. */

#define FRAMES YES      /* onward. */

#define INDENT YES

#define REF_ONLY YES    /* option to skip orphan check which takes forever.*/

#define DONT_FIX_CASE YES /* default to no case complaints. */

#define FIXFILE YES     /* file: refs are error. */

#define GHTTP YES       /* filter-out {{ index.htm (455): couldn't find
graphics
"http://www.e-zeeinternet.com/count.php?page=932632&amp;style=bck-old&amp;nbdigits=5"
}} */

#define R_CASE YES      /* make -r also lower-case check */

/****************************************************************************
****************************************************************************/
#ifdef __FLAT__
//didn't actually test this code; used in s38 nonsense.
/****************************************************************************

0: returns the next keystroke. Much mumbo-jumbo probably thrown away.

1: if no keystroke available, returns 0. Else returns the keystroke -- SAVING
   it for the next bioskey(0).

2: returns the current shift key status. I'm not doing this today.

uses <conio.h>

****************************************************************************/

_f int bioskey(int what) {
  static int previous;

  switch (what) {
    case 1:
    if (!previous) {        //if no previous character gotten.

      if (kbhit()) {        //check for a character.
        previous = getch(); //save it for subsequent calls.
        return previous;    //and return it.
      }
      return 0;             //no previous, no kbhit(); return 0.
    }
    return previous;        //there is a previous. keep returning it.

    case 0:
    if (previous) {
      int t=previous;
      previous = 0;
      return t;
    }

    return getch();

    default:
//    case 2:
    return 0;

  }
}

#endif



/****************************************************************************
****************************************************************************/
char *iname="*.htm", *thisname, *oname;

unsigned int Glinecount, Glinenumber;

#if INDENT
int Gindent=25;
#endif

#if REF_ONLY
int refonly;
#endif

FILE *thingfile;
FILE *ofile
#if !defined(__FLAT__)
=stdout
#endif
;

#define SEPARATOR   "---------------\n"

#define RNAME       "linkoid~.txt"
#define CWDNAME     "cwd:   "
#define HTMNAME     "name:  "
#define REFNAME     "ref:   "
#define IMGNAME     "image: "
#define MARKNAME    "mark:  "

#define NAMESIZE   /*1234567*/ (7)

#define NUMTAG " line#<"
#define NUMCLOSE ">"

#define NUMSTRING NUMTAG "%u" NUMCLOSE


char *refname=RNAME;


/*these are apparently both used to open refname in r mode. */
FILE *reffile;
FILE *reffind;

int deleteref=YES, dontkey=NO;

#ifdef __FLAT__
#define MAX95PATH MAXPATH
#define MAX95EXT MAXEXT
#else
#define MAX95PATH (270)
#define MAX95EXT (5)
#endif

int
http,       /* if set, check http: refs, 'though don't know how. */
othercolon, /* if set "bingo:" refs. */
unlinked=YES
;

#if defined(__FLAT__)
#define UNHTM "*.htm*"
#else
#define UNHTM "*.htm"
#endif



#define TARGETCASE defined(__FLAT__) /* check case of target. */
#define CASECOMP   defined(__FLAT__) /* check for case comparison between ref
and target. */

#define CASE_TARGET (TARGETCASE || CASECOMP)



/****************************************************************************
****************************************************************************/

#if defined(__FLAT__)
void *findfinish(struct ffblk *ffblk) {
  findclose(ffblk);
  return NULL;
}
#else
#define findfinish(x) NULL
#endif

/* If name, returns first next instance of name (NULL if none). If name==NULL,
returns next (NULL if none). */

_f char *getwild(char *name) {
  static char path[MAXPATH], drive[MAXDRIVE],
  dir[MAXDIR], file[MAXFILE], ext[MAXEXT];
  static struct ffblk ffblk;
  if (name) {
    fnsplit(name,drive,dir,file,ext);
    if (findfirst(name,&ffblk,0))
    return findfinish(&ffblk);
  }
  else {
    if (findnext(&ffblk))
    return findfinish(&ffblk);
  }
  fnsplit(ffblk.ff_name,NULL, NULL,file,ext);
  fnmerge(path,drive,dir,file,ext);
  return path;
}

/****************************************************************************
this version requires you to supply an ffblk, doesn't bother with that
directory nonsense, and returns an allocated string.
****************************************************************************/

#if 0
_f char *gitwild(char *name, struct ffblk *ffblk) {
  if (name) {
    if (findfirst(name,ffblk,0))
    return findfinish(ffblk);
  }
  else {
    if (findnext(ffblk))
    return findfinish(ffblk);
  }
  return strdup(ffblk->ff_name);
}
#endif

/****************************************************************************
****************************************************************************/

/* strstr but ignore case. */
_f char *stristr(char *target, char *what) {
  int length;

  if (length=strlen(what)) {
    while (*target) {
      if (!(strnicmp(target,what,length)))
      return target;
      ++target;
    }
  }
  return NULL;
}

/* if what is what's on left in target, return NZ. */
_f int strleft(char *target, char *what) {
  int length;

  return
  (length=strlen(what)) &&
  (!(strnicmp(target,what,length)))
  ;

}

int Gerrors;

FILE *errout
#if !defined(__FLAT__)
=stderr
#endif
;
/* returns -1 so functions can return it as error I guess. */
_f int erprintf(int terminal, char *format, ...) {
  va_list argptr;

  Gerrors++;

  va_start(argptr, format);
  vfprintf(errout,format,argptr);
  va_end(argptr);
  fputc('\n',errout);
  if (terminal)
  exit(terminal);
  return -1;
}

_f void mustopen(FILE **f, char *name, char *mode) {
  if (!(*f=fopen(name,mode))) {
    fprintf(stderr,"couldn't open %s for %s.",name,mode);
    exit(3);
  }
}

/* returns the next available place there in d. */
_f char *catmax(char *d, char *s, int max) {
  char *e;
  if (max<2)
  return NULL;            /* Fri 03-09-2001. */
  --max;                  /* leave room for term. */
  e=strchr(d,'\0');       /* e points at end. */
  while(
  ((e-d) < max) &&
  (*e++ = *s++)           /* we were probably reading past end in 32-bit land.
                          */
  );

  *e='\0';        /* should terminate anyway. */

  return e;
}

/* scan off of spaces in s; stop at any non-blank, including \0, \n. Return
1 if end of line -- \n \0, else 0. Mon 05-15-1995 version.*/
_f int scans(char **s) {
  while (**s && (**s<=' ') && (**s != '\n') )
  ++(*s);

  return **s=='\n' || **s=='\0';
}


#define ISIBMGRAF(x) (x > ' ')
/* if u use  et al, scanchar'll fail without this. isgraf() is compatible. */
/* scan off of characters in s; stop at any blank, including \0, \n. Return 1
if end of line -- \n \0, else 0. */
_f int scanchar(char **s) {
  while(ISIBMGRAF(**s)) ++(*s);
  return **s=='\n' || **s=='\0';
}

/* if characters, scan off them. scan off spaces. */
_f field(char **s) {
  scanchar(s);
  return scans(s);
}

_f char *f0gets(char *string, int n, FILE *stream) {
  char *p, *t;
  if ( (p=fgets(string,n,stream)) &&
       (t=strchr(p,'\n')) ) *t='\0';
  return p;
}

/* return nz if file name exists. evades append. */
_f int exist(char *name) {
  return !access(name,0);
}


/****************************************************************************
prints the culprit, (linenumber), indent, the rest of the story + \n, to
ofile.
****************************************************************************/

_f void offense(char *culprit, char *format, ...) {
  va_list argptr;
  int count;

  ++Gerrors;

  count = fprintf(ofile,"%s (%d): ",culprit,Glinenumber);

  while(count++ < Gindent)
  fputc(' ',ofile);

  va_start(argptr, format);

  vfprintf(ofile,format,argptr);

  va_end(argptr);

  fputc('\n',ofile);

}

/****************************************************************************
****************************************************************************/
#define BSIZE (2000)
char abuffo[BSIZE+2];

typedef enum {
  NOTHING=0,
  LEFTANGLE,
  RIGHTANGLE,
  EQUALS,
  QUOTED,           /* in abuffo. */
  AWORD,            /* in abuffo. None of the below: */
  LETTERA,          /* what's in abuffo. "A". */
  HREF,             /* "HREF". */
#if FRAMES
  FRAME,            /* <frame src="b_index.htm"> */
#endif
  IMG,              /* etc. */
  SRC,
  NAME,
  BODY,
  BACKGROUND

} THINGTYPE;


int gotrightangle;
/* set when right angle is gotten; must be reset by others. */

THINGTYPE getthing(void) {
  int c, index;

  if (gotrightangle)
  return RIGHTANGLE;

  while (1) {
    c = getc(thingfile);
    switch (c) {
      case EOF:
      return NOTHING;

      case '>':
      gotrightangle=YES;
      return RIGHTANGLE;

      case '<':
      return LEFTANGLE;

      case '=':
      return EQUALS;

      case '\n':
      Glinecount++;

      case ' ':
      continue;

      case '"':
      index = 0;
      while(1) {
        c = getc(thingfile);

        if (c=='\n') {
          Glinecount++;
          return QUOTED; /* should've done this anyway, although HTML is
          broken.*/
        }

        if (
        (c==EOF) ||
        (c=='"')
        )
        return QUOTED;

        if (c<' ')
        continue;         /* just skip junk. */

        if (index<BSIZE) {
          abuffo[index++] = c;
          abuffo[index]='\0';
        }

      }

      default:
      if (c<=' ')
      continue;

/* ok it's a normal character. Assemble a word. */
      index = 1;
      abuffo[0]=c;
      abuffo[1]='\0';

      while(1) {
        c = getc(thingfile);

        if (
        (c<=' ') ||
        (ispunct(c))
        ) {  /* end of word. */
          ungetc(c,thingfile);
          if (!stricmp(abuffo,"A"))
          return LETTERA;
#if FRAMES
          if (!stricmp(abuffo,"FRAME"))
          return FRAME;
#endif
          if (!stricmp(abuffo,"HREF"))
          return HREF;
          if (!stricmp(abuffo,"IMG"))
          return IMG;
          if (!stricmp(abuffo,"SRC"))
          return SRC;
          if (!stricmp(abuffo,"NAME"))
          return NAME;

          if (!stricmp(abuffo,"BODY"))
          return BODY;
          if (!stricmp(abuffo,"BACKGROUND"))
          return BACKGROUND;

          return AWORD; /* none of the above. */
        }
/* ok still got more word. */
        if (index<BSIZE) {
          abuffo[index++] = c;
          abuffo[index]='\0';
        }
      }
    }
/* so it's not one of our exciting punctuations. */
  }
}


/****************************************************************************
so the things I want are

<A HREF="rant4.htm#bscam">              a bookmark reference.
<A HREF="index.htm">                    a local page reference.

<IMG SRC="homebut.gif" WIDTH="100" HEIGHT="50" VSPACE="0" SRC="javabut.gif"
WIDTH="100" HEIGHT="50" VSPACE="0" HSPACE="0" BORDER="0">
                                        image reference.

<A NAME="bscam">                        a bookmark target.


<A HREF="http://home.sprynet.com/sprynet/leora/index.htm">
a web page reference.

<BODY BACKGROUND="clouds2.jpg">

****************************************************************************/
#define MAXREFS (2000)
#define MAXIMAGES (2000)
#define MAXMARKS (2000)

void dumpangle(THINGTYPE thing) {

  if (gotrightangle) {
    gotrightangle=NO;
    return;
  }

  while (
  (thing != RIGHTANGLE) &&
  (thing=getthing())
  );
}


void findrefs(char *name) {
  THINGTYPE thing;

#if DEBUGBSCAM
  if (stristr(name,"bscam"))
  fprintf(stderr,"findreffing bscam\n");
#endif

  Glinecount = 1;
  mustopen(&thingfile,name,"r");

  fprintf(reffile,SEPARATOR HTMNAME "%s\n",strlwr(name));

  while(thing=getthing()) {
    gotrightangle = NO;   /* reset gotrightangle trap. */

    if (thing==LEFTANGLE) {
      if (
      (thing=getthing())==RIGHTANGLE
      )
      continue;

#if FRAMES
      if (thing==FRAME) {
        while(thing=getthing()) {
          if (thing==SRC) {
            if (
            (getthing()==EQUALS) &&
            ((thing=getthing())==QUOTED)
            ) {
              fprintf(reffile,REFNAME "%s" NUMSTRING "\n",abuffo,Glinecount);
            }
          }
          else if (thing==RIGHTANGLE)
          break;
        }
        dumpangle(thing);
      }
      else
#endif

      if (thing==LETTERA) {
        while(thing=getthing()) {
          if (thing==HREF) {
            if (
            (getthing()==EQUALS) &&
            ((thing=getthing())==QUOTED)
            ) {
              fprintf(reffile,REFNAME "%s" NUMSTRING "\n",abuffo,Glinecount);
            }
          }
          else if (thing==NAME) {
            if (
            (getthing()==EQUALS) &&
            (thing=getthing()==QUOTED)
            ) {
              fprintf(reffile,MARKNAME "%s" NUMSTRING "\n",abuffo,Glinecount);
            }
          }
          else if (thing==RIGHTANGLE)
          break;
        }
        dumpangle(thing);
      }
      else if (thing==IMG) {
        while(thing=getthing()) {
          if (thing==SRC) {
            if (
            (getthing()==EQUALS) &&
            ((thing=getthing())==QUOTED)
            ) {
              fprintf(reffile,
              IMGNAME "%s" NUMSTRING "\n",abuffo,Glinecount);
            }
          }
          else if (thing==RIGHTANGLE)
          break;
        }
      }
      else if (thing==BODY) {
        while(thing=getthing()) {
          if (thing==BACKGROUND) {
            if (
            (getthing()==EQUALS) &&
            ((thing=getthing())==QUOTED)
            ) {
              fprintf(reffile,
              IMGNAME "%s" NUMSTRING "\n",abuffo,Glinecount);
            }
          }
          else if (thing==RIGHTANGLE)
          break;
        }
      }

      dumpangle(thing);
    }
  }
  fclose(thingfile);
}

/****************************************************************************
%7E
****************************************************************************/
int fixcase=
#if DONT_FIX_CASE
0
#else
'l'
#endif
;

int hasupper(char *s) {
  if (!s)
  return NO;
  while(*s) {
    if (
    (*s=='%') &&
    (s[1]) &&
    (s[2])
    ) {
      s += 3;   /* skip %7E */
      continue;
    }
    if (isupper(*s))
    return YES;
    ++s;
  }
  return NO;
}


int haslower(char *s) {
  if (!s)
  return NO;

  while(*s) {
    if (islower(*s))
    return YES;
    ++s;
  }
  return NO;
}

#if CASE_TARGET
char *target(char *ref) {
  static struct ffblk ffblk;
  char *r;

  if (findfirst(ref,&ffblk,0))
  r=NULL;
  else
  r=ffblk.ff_name;

  findclose(&ffblk);

  return r;
}
#endif


void checkcase(char *cwd, char *localname, char *ref) {
  char *t;
  if (fixcase) {
#if CASE_TARGET
    t = target(ref);
#endif
    switch(fixcase) {

      case 'l':
      if (hasupper(ref))
#if INDENT
      offense(localname,"upper case in \"%s\"",ref);
#else
      fprintf(ofile,"%s (%u): upper case in \"%s\"\n",
      localname,Glinenumber,ref);
#endif

#if TARGETCASE
      if (hasupper(t))
      /* someone else finds missing */

#if INDENT
      offense(localname,"upper case in file name \"%s\"",t);
#else
      fprintf(ofile,"%s (%u): upper case in file name \"%s\"\n",
      localname,Glinenumber,t);
#endif

#endif
      break;

      case 'u':

      if (haslower(ref))
#if INDENT
      offense(localname,"lower case in \"%s\"",ref);
#else
      fprintf(ofile,"%s (%u): lower case in \"%s\"\n",
      localname,Glinenumber,ref);
#endif

#if TARGETCASE
      if (haslower(t))

#if INDENT
      offense(localname,"lower case in file name %s",t);
#else
      fprintf(ofile,"%s (%u): lower case in file name %s\n",
      localname,Glinenumber,t);
#endif

#endif

      break;
    }
#if CASECOMP
    if (t && strcmp(ref,t))

#if INDENT
    offense(localname,"case in \"%s\" differs from file name \"%s\"",ref,t);
#else
    fprintf(ofile,"%s (%u): case in \"%s\" differs from file name \"%s\"\n",
    localname,Glinenumber,ref,t);
#endif

#endif

  }
}

/****************************************************************************
Now the point is, everything should be in this wretched ref file now.
****************************************************************************/

int filereference(char *kind, char *cwd, char *localname, char *ref) {
  char ext[MAX95EXT];
  fnsplit(ref,NULL,NULL,NULL,ext);
  if (
  (!stricmp(ext,".htm")) ||
  (!stricmp(ext,".html"))
  )
  return NO;

  if (!kind)
  kind="file";

/* anything without we decide is a file. */
  if (exist(ref))
  return YES;

/* oops failure. */
#if INDENT
  offense(localname,"couldn't find %s \"%s\"",kind,ref);
#else
  fprintf(ofile,"%s (%u): couldn't find %s \"%s\"\n",
  localname,Glinenumber,kind,ref);
#endif
  return YES;   /* but still tell them we took care of it. */


}

/****************************************************************************
****************************************************************************/

char *nonumb_gets(char *string, int n, FILE *stream) {
  char *r, *p;

  if (
  (r=f0gets(string,n,stream)) &&
  (p=stristr(r,NUMTAG))
  )
  *p='\0';

  return r;

}

/****************************************************************************
****************************************************************************/

void checkreference(char *cwd, char *localname, char *ref) {
  char *bookmark=NULL;
  int intarget=NO;

#if FIXFILE
  if (!strnicmp(ref,"file:",5)) {
    fprintf(ofile,"%s (%u): evil \"file:\" ref \"%s\"\n",
    localname,Glinenumber,ref);
    return;
  }

#endif

  if (!strnicmp(ref,"http:",5)) {
    if (http)
#if INDENT
    offense(localname,"don't understand \"%s\"",ref);
#else
    fprintf(ofile,"%s (%u): don't understand \"%s\"\n",
    localname,Glinenumber,ref);
#endif
    return;
  }

  if (strchr(ref,':')) {
    if (othercolon)
#if INDENT
    offense(localname,"don't understand \"%s\"",ref);
#else
    fprintf(ofile,"%s (%u): don't understand \"%s\"\n",
    localname,Glinenumber,ref);
#endif
    return;
  }

  if (bookmark=strchr(ref,'#'))
  *bookmark++ = '\0';

  else if (filereference(NULL,cwd,localname,ref))
  return;

  if (!*ref) {
    ref=localname;
  }

  rewind(reffind);

  while (nonumb_gets(abuffo,BSIZE,reffind)) {
    if (!strnicmp(abuffo,HTMNAME,NAMESIZE)) {
      if (!strcmp(ref,abuffo+NAMESIZE)) {
        if (intarget)     /* we were in the target and didn't find the thing */
        goto FAILURE;
        if (!bookmark)
        return;           /* no error. The referenced file exists. */
        intarget=YES;
      }
      else
      intarget=NO;  /* surely this should be here? Thu 7/19/01 12:05 pm. //
                    Yeah fixed bscam bug. */
    }
    else if (
    intarget &&
    (!strnicmp(abuffo,MARKNAME,NAMESIZE)) &&
    (!strcmp(abuffo+NAMESIZE,bookmark))
    ) {
      return;  /* a match. */
    }
  }

  FAILURE:

  if (bookmark)
#if INDENT
  offense(localname,"couldn't find \"%s#%s\"",ref,bookmark);
#else
  fprintf(ofile,"%s (%u): couldn't find \"%s#%s\"\n",
  localname,Glinenumber,ref,bookmark);
#endif
  else
#if INDENT
  offense(localname,"couldn't find \"%s\"",ref);
#else
  fprintf(ofile,"%s (%u): couldn't find \"%s\"\n",
  localname,Glinenumber,ref);
#endif

}

void checkimage(char *cwd, char *localname, char *ref) {
#if GHTTP
  if (
  (!http) &&
  strleft(ref,"http://")
  )
  return;
#endif

  filereference("graphics",cwd,localname,ref);
}

/****************************************************************************
returns the allocated reference, but also sets Glinenumber to numeric value, if
present.
****************************************************************************/

char *produceref_number(char *from) {
  char *p;

  Glinenumber=0; /* signal no number. */

  if (p = stristr(from,NUMTAG)) {
    Glinenumber = atoi(p+(sizeof(NUMTAG)-1));
    *p='\0';
  }

  return
  strdup(from);

}

/****************************************************************************
resolverefs() goes through reffile, which is opened twice for read. For each
entry in the ref file, it attempts to locate the reference.
****************************************************************************/


void resolverefs(void) {
  char *ref, *cwd=NULL, *fname=NULL;
  while (f0gets(abuffo,BSIZE,reffile)) {
    if (!strnicmp(abuffo,CWDNAME,NAMESIZE)) {
      if (cwd)
      free(cwd);
      cwd=produceref_number(abuffo+NAMESIZE);
    }
    else if (!strnicmp(abuffo,HTMNAME,NAMESIZE)) {
      if (fname)
      free(fname);
      fname=produceref_number(abuffo+NAMESIZE);
    }
    else if (!strnicmp(abuffo,REFNAME,NAMESIZE)) {
      ref=produceref_number(abuffo+NAMESIZE);
#if DEBUGBSCAM
      if (stristr(ref,"BSCAM"))
      fprintf(stderr,"found bscam in resolverefs\n");
#endif
      checkcase(cwd,fname,ref);
      checkreference(cwd,fname,ref);
      free(ref);
    }
    else if (!strnicmp(abuffo,IMGNAME,NAMESIZE)) {
      ref=produceref_number(abuffo+NAMESIZE);
      checkcase(cwd,fname,ref);
      checkimage(cwd,fname,ref);
      free(ref);
    }
  }

  if (cwd)
  free(cwd);

  if (fname)
  free(fname);
}

/****************************************************************************
process() goes through inames and extracts references (in ascii text) to the
reffile.
****************************************************************************/

void process(void) {

  if (!(thisname=getwild(iname)))
  erprintf(NO,"no %s",iname);

  while(thisname) {

/*    fprintf(stderr,"(checking %s...)\n",thisname);   */
/* too fast. */

    findrefs(thisname);

    thisname = getwild(NULL);
  }
}

/****************************************************************************
goes through *.htm* looking for thisname.
****************************************************************************/
int GotThisName(char *unalloc) {
  FILE *ifile;

  ifile = fopen(unalloc,"r");
  if (!ifile) {
    erprintf(NO,"couldn't open %s",unalloc);
    return NO;
  }
  else {
    while (f0gets(abuffo,BSIZE,ifile)) {
      if (stristr(abuffo,thisname)) {
        fclose(ifile);
        return YES;     /* it's a hit. */
      }
    }
    fclose(ifile);
  }
  return NO;
}


void islinked(void) {
  char *fname=NULL;

  rewind(reffile);

  while (f0gets(abuffo,BSIZE,reffile)) {
    if (!strnicmp(abuffo,HTMNAME,NAMESIZE)) {
      if (GotThisName(abuffo+NAMESIZE))
      return;
    }
  }

/* nobody there. */
  fprintf(ofile,"Couldn't find \"%s\" mentioned\n",thisname);

}


/****************************************************************************
unlinking(char *ename) goes through the iname files, and attempts to locate
them in the ref file in the ename type entry.

****************************************************************************/
void unlinking(void) {

  if (!(thisname=getwild(iname)))
  return; /* presumably somebody alreday complained. */

  fprintf(stderr,"(checking for unlinked %s....)\n",iname);

  while(thisname) {
    islinked();
    thisname = getwild(NULL);
  }
}



/****************************************************************************
linkoid [afn [afn...]   Copyright 2001-2012 j.g. owen (`" __DATE__ `")
searches through afns (ambiguous file names, i.e. *.html etc.) looking for
links. If no afns, uses "*.htm". Then outputs the exciting things it found. If
errors, might set errorlevel to 1; else 0.
-oOutputfile  name output file; otherwise stdout.
-iRefname   name the reference file; otherwise it's `" RNAME `"
-d-         don't delete reference file; it's kind of amusing.
-hFail finding http: refs, including graphics php etc. Otherwise don't try.
-:Fail find "other:" refs. Etc.
`a#if DONT_FIX_CASE
-cl   (lower-case L) complain if upper-case; -cu lower; -cd different.
-r    Check references only; skip time-consuming unreferenced (orphan) check.
`a#else
-cl   (lower-case L; default): complain if anything is upper-case.
-cu   complain if anything is lower-case.
-cd   just complain if different.
-c    don't complain about case.
-r    Check references only; skip time-consuming unreferenced (orphan) check
      and don't report case errors. ("-r -cl" etc. to report case anyway);
      checks for keypress @ exit. Except if -k-.
`a#endif
-u-   don't look around for unlinked *.zip *.exe *.gif *.jpg `" UNHTM `" in
      afn etc.
-a25  Set indent between ref and complaint.
`a#ifdef __FLAT__
(w32)
`a#endif

****************************************************************************/

depart() {
  printf(










"linkoid [afn [afn...]   Copyright 2001-2012 j.g. owen (" __DATE__ ")\n"
"searches through afns (ambiguous file names, i.e. *.html etc.) looking for\n"
"links. If no afns, uses \"*.htm\". Then outputs the exciting things it found. If\n"
"errors, might set errorlevel to 1; else 0.\n"
"-oOutputfile  name output file; otherwise stdout.\n"
"-iRefname   name the reference file; otherwise it's " RNAME "\n"
"-d-         don't delete reference file; it's kind of amusing.\n"
"-hFail finding http: refs, including graphics php etc. Otherwise don't try.\n"
"-:Fail find \"other:\" refs. Etc.\n"
#if DONT_FIX_CASE
"-cl   (lower-case L) complain if upper-case; -cu lower; -cd different.\n"
"-r    Check references only; skip time-consuming unreferenced (orphan) check.\n"
#else
"-cl   (lower-case L; default): complain if anything is upper-case.\n"
"-cu   complain if anything is lower-case.\n"
"-cd   just complain if different.\n"
"-c    don't complain about case.\n"
"-r    Check references only; skip time-consuming unreferenced (orphan) check\n"
"      and don't report case errors. (\"-r -cl\" etc. to report case anyway);\n"
"      checks for keypress @ exit. Except if -k-.\n"
#endif
"-u-   don't look around for unlinked *.zip *.exe *.gif *.jpg " UNHTM " in\n"
"      afn etc.\n"
"-a25  Set indent between ref and complaint.\n"
#ifdef __FLAT__
"(w32)\n"
#endif












  );


  exit(17);
}



/****************************************************************************
****************************************************************************/
#define QUESTIONS(s) if ((s) && (strchr(s,'?'))) depart()

_f notminus(char *arg) {
  return arg[2] != '-';
}

#define NOTMINUS() (notminus(argv[i]))


int main(int argc, char *argv[]) {
  char *p;
  int nonops=0, i, opmark='-';        /* do options. */
#if defined(__FLAT__)
  ofile = stdout;
  errout = stderr;
#endif

  Gerrors = 0;

  for (i=1; i<argc; ++i) {
    if (argv[i][0]=='/') opmark='/';
/* / forces it to use / subsequently, so u can have files with -. */

    QUESTIONS(argv[i]);

    if (argv[i][0]==opmark) {
      switch (argv[i][1]) {
        case 0: break;
        /* make option alone OK, so he can use files with -. */

        case ':':
        othercolon=NOTMINUS();
        break;

#if INDENT
        case 'a':
        Gindent=atoi(argv[i]+2);
        break;
#endif

        case 'c':
        switch(argv[i][2]) {
          case 'u':
          case 'l':
          case 'd':
          case  0:
          fixcase=argv[i][2];
          break;

          default:
          depart();
        }
        break;

        case 'd':
        deleteref = NOTMINUS();
        break;

        case 'k':
        dontkey = !NOTMINUS();
        break;

        case 'h':
        http=NOTMINUS();
        break;

        case 'i':
        refname=argv[i]+2;
        break;

        case 'o':
        oname=argv[i]+2;
        break;

#if REF_ONLY
        case 'r':
        refonly = NOTMINUS();
#if R_CASE
        fixcase = 'd';
#else
        fixcase = NO;
#endif
        break;
#endif

        case 'u':
        unlinked = NOTMINUS();
        break;

        default:
        depart();
      }
    }
    else
    ++nonops;
  }

  if (oname)
  mustopen(&ofile,oname,"w");

  fprintf(ofile,SEPARATOR);

  mustopen(&reffile,refname,"w");

  fprintf(reffile,SEPARATOR CWDNAME "%s\n",strlwr(p=getcwd(NULL,MAX95PATH)));
  free(p);

  if (nonops) {
    for (i=1; i<argc; ++i) {
      if (argv[i][0]=='-')
      continue;

      iname = argv[i];

      process();

    }
  }
  else
  process();  /* with default iname. */

  fclose(reffile);

  fprintf(stderr,"(checking references....)\n");

  mustopen(&reffile,refname,"r");
  mustopen(&reffind,refname,"r");

  resolverefs();

  if (unlinked
#if REF_ONLY
  && (!refonly)
#endif
  ) {
    iname = UNHTM;
    unlinking();

    iname = "*.jpg";
    unlinking();

    iname = "*.gif";
    unlinking();

    iname = "*.png";
    unlinking();

    iname = "*.exe";
    unlinking();

    iname = "*.zip";
    unlinking();

    iname = "*.dmg";  /* macintosh! */
    unlinking();

  }

  fclose(reffile);
  fclose(reffind);

  if (deleteref)
  unlink(refname);

  if (refonly && (!dontkey)) {
    fputs("(press a key)",stderr);
    bioskey(0);
  }

  if (Gerrors)
  return 1;

  return 0;

}



